# ]po[ Financial Documents
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](https://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](https://www.project-open.com/en/list-installers)

About ]po[ Financial Documents:

<p><p>Allows to create, send and track the payment of invoices. The module supports multiple invoice templates and the invoicing of multiple projects in a single invoice. Invoicing can be an important part of the administrative work in a consulting company. This is particularly true if the company bills their customer on a per-effort base. This document explains the different billing scenarios and how they are covered by <span class="brandsec">]</span><span class="brandfirst">project-open</span><span class="brandsec">[</span>. 

# Online Reference Documentation

## Fixed Price Projects



## Fixed Price Projects With Multiple Invoices



## Many Small Projects



## Cost Based Projects



## Maintenance Projects



## Repeating Invoices



## Consistency Checks



## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/lib/finance-document-comparison.adp">lib/finance-document-comparison.adp</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/lib/finance-document-comparison.tcl">lib/finance-document-comparison.tcl</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=601&amp;path=packages/intranet-invoices/tcl/intranet-invoices-procs.tcl">tcl/intranet-invoices-procs.tcl</a></b></td><td></td><td>Bring together all &quot;components&quot; (=HTML + SQL code) related to Invoices </td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_change_oo_content">im_invoice_change_oo_content</a></b></td><td></td><td>Takes the provided contents and places them in the content.xml file of the odt file, effectivly changing the content of the file. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_item_permissions">im_invoice_item_permissions</a></b></td><td></td><td>Fill the &quot;by-reference&quot; variables read, write and admin with the permissions of $current_user_id on $user_id </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_item_status_active">im_invoice_item_status_active</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_item_status_deleted">im_invoice_item_status_deleted</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_item_type_default">im_invoice_item_type_default</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_nr_variant">im_invoice_nr_variant</a></b></td><td></td><td>Returns the next available &quot;variant&quot; of an invoice number. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_oo_tdom_explore">im_invoice_oo_tdom_explore</a></b></td><td></td><td>Returns a hierarchical representation of a tDom tree representing the content of an OOoo document in this case. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_payment_method_select">im_invoice_payment_method_select</a></b></td><td></td><td>Returns an html select box named $select_name and defaulted to $default with a list of all the partner statuses in the system </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_permissions">im_invoice_permissions</a></b></td><td></td><td>Fill the &quot;by-reference&quot; variables read, write and admin with the permissions of $current_user_id on $user_id </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_rounding_factor">im_invoice_rounding_factor</a></b></td><td></td><td>Gets the right rounding factor per currency. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_rounding_factor_helper">im_invoice_rounding_factor_helper</a></b></td><td></td><td>Gets the right rounding factor per currency A rf (rounding factor) of 100 indicates two digits after the decimal separator precision. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoice_update_rounded_amount">im_invoice_update_rounded_amount</a></b></td><td></td><td>Updates the invoice amount, based on funny rounding rules for different currencies. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoices_check_for_multi_project_invoices">im_invoices_check_for_multi_project_invoices</a></b></td><td></td><td>Check if there are invoices around that are assoicated with more then one project. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoices_default_company_contact">im_invoices_default_company_contact</a></b></td><td></td><td>Return the most appropriate company contact for an invoice. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoices_default_company_template">im_invoices_default_company_template</a></b></td><td></td><td>Business logic to determine the default invoice template for the given cost type at the given company. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoices_finance_document_comparison_component">im_invoices_finance_document_comparison_component</a></b></td><td></td><td>Returns a HTML table with a comparison of the volume of FinDocs per type and outline_number. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoices_object_list_component">im_invoices_object_list_component</a></b></td><td></td><td>Returns a HTML table containing a list of objects associated with a particular financial document. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoices_select">im_invoices_select</a></b></td><td></td><td>Returns an html select box named $select_name and defaulted to $default with a list of all the invoices in the system. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_invoices_unify_select_projects">im_invoices_unify_select_projects</a></b></td><td></td><td>Input is the list of projects related to a financial document. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_next_invoice_nr">im_next_invoice_nr</a></b></td><td></td><td>Returns the next free invoice number. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=601&amp;proc=im_package_invoices_id">im_package_invoices_id</a></b></td><td></td><td></td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-invoices&amp;url=common/intranet-invoices-backup.sql&amp;version_id=601">sql/common/intranet-invoices-backup.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-invoices&amp;url=common/intranet-invoices-common.sql&amp;version_id=601">sql/common/intranet-invoices-common.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-invoices&amp;url=postgresql/intranet-invoices-create.sql&amp;version_id=601">sql/postgresql/intranet-invoices-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-invoices&amp;url=postgresql/intranet-invoices-drop.sql&amp;version_id=601">sql/postgresql/intranet-invoices-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-invoices&amp;url=postgresql/upgrade/upgrade-5.0.0.0.2-5.0.0.0.3.sql&amp;version_id=601">sql/postgresql/upgrade/upgrade-5.0.0.0.2-5.0.0.0.3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-invoices&amp;url=postgresql/upgrade/upgrade-5.0.2.4.0-5.0.2.5.0.sql&amp;version_id=601">sql/postgresql/upgrade/upgrade-5.0.2.4.0-5.0.2.5.0.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-invoices&amp;url=postgresql/upgrade/upgrade-5.0.2.5.0-5.0.2.5.1.sql&amp;version_id=601">sql/postgresql/upgrade/upgrade-5.0.2.5.0-5.0.2.5.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-invoices&amp;url=postgresql/upgrade/upgrade-5.0.2.5.4-5.0.2.5.5.sql&amp;version_id=601">sql/postgresql/upgrade/upgrade-5.0.2.5.4-5.0.2.5.5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-invoices&amp;url=postgresql/upgrade/upgrade-5.0.2.5.5-5.0.2.5.6.sql&amp;version_id=601">sql/postgresql/upgrade/upgrade-5.0.2.5.5-5.0.2.5.6.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/dashboard.adp">dashboard.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/dashboard.tcl">dashboard.tcl</a></b></td><td>Offers a menu to create new Invoices, Quotes, POs and Bills</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/index.tcl">index.tcl</a></b></td><td>Empty redirection index.tcl file</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/invoice-action.tcl">invoice-action.tcl</a></b></td><td>Purpose: Takes commands from the /intranet/invoices/index page and deletes invoices where marked</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/invoice-association-action-2.tcl">invoice-association-action-2.tcl</a></b></td><td>Associates an object with an invoice (financial document)</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/invoice-association-action.adp">invoice-association-action.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/invoice-association-action.tcl">invoice-association-action.tcl</a></b></td><td>Allows to &quot;associate&quot; a project with a financial document.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/invoice-discount-surcharge-action.tcl">invoice-discount-surcharge-action.tcl</a></b></td><td>Adds lines for discount/surcharge to the Invoice</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/list.adp">list.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/list.tcl">list.tcl</a></b></td><td>List all invoices together with their payments</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new-2.tcl">new-2.tcl</a></b></td><td>Saves invoice changes and set the invoice status to &quot;Created&quot;.&lt;br&gt; Please note that there are different forms to create invoices for example in the intranet-trans-invoicing module of the intranet-server-hosting module.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new-copy-custselect.adp">new-copy-custselect.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new-copy-custselect.tcl">new-copy-custselect.tcl</a></b></td><td>Copy existing financial document to a new one.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new-copy-invoiceselect.adp">new-copy-invoiceselect.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new-copy-invoiceselect.tcl">new-copy-invoiceselect.tcl</a></b></td><td>Copy existing financial document to a new one.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new-copy.adp">new-copy.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new-copy.tcl">new-copy.tcl</a></b></td><td>Copy existing financial document to a new one.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new-cost-center-select.adp">new-cost-center-select.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new-cost-center-select.tcl">new-cost-center-select.tcl</a></b></td><td>Determine the cost center (i.e.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new.adp">new.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/new.tcl">new.tcl</a></b></td><td>Receives the list of tasks to invoice, creates a draft invoice (status: &quot;In Process&quot;) and displays it.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/notify.adp">notify.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/notify.tcl">notify.tcl</a></b></td><td>Purpose: Send an email to the accounting/project contact to inform about the invoice.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/payment-action.tcl">payment-action.tcl</a></b></td><td>Purpose: Takes commands from the /intranet/invoices/index page and deletes invoices where marked</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/view.adp">view.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=601&amp;path=packages/intranet-invoices/www/view.tcl">view.tcl</a></b></td><td></td></tr></table>

